import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/api-public';

import { _MODULE_CONFIG } from './config/token';

import { PublicApiService } from './services/public-api.service';

const SERVICES = [PublicApiService];

@NgModule({})
export class PublicApiRootModule {}

@NgModule({})
export class PublicApiModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<PublicApiRootModule> {
    return {
      ngModule: PublicApiRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
