import { NgModule, ModuleWithProviders } from '@angular/core';

import { ModuleConfig } from '@ucap/protocol-room';

import { _MODULE_CONFIG } from './config/token';

import { RoomProtocolService } from './services/room-protocol.service';

const SERVICES = [RoomProtocolService];

@NgModule({})
export class RoomProtocolRootModule {}

@NgModule({})
export class RoomProtocolModule {
  public static forRoot(
    config: ModuleConfig
  ): ModuleWithProviders<RoomProtocolRootModule> {
    return {
      ngModule: RoomProtocolRootModule,
      providers: [{ provide: _MODULE_CONFIG, useValue: config }, ...SERVICES]
    };
  }
}
