import { Selector, createSelector } from '@ngrx/store';

import { AuthResponse } from '@ucap/protocol-query';
import { RegViewResponse } from '@ucap/protocol-option';

export interface State {
  authResponse?: AuthResponse | null;
  regViewResponse: RegViewResponse | null;
}

export const initialState: State = {
  authResponse: null,
  regViewResponse: null
};

export function selectors<S>(selector: Selector<any, State>) {
  return {
    authResponse: createSelector(
      selector,
      (state: State) => state.authResponse
    ),
    regViewResponse: createSelector(
      selector,
      (state: State) => state.regViewResponse
    )
  };
}
