import { Selector, createSelector } from '@ngrx/store';

import { VersionInfo2Response } from '@ucap/api-public';
import { UrlInfoResponse } from '@ucap/api-external';

export interface State {
  versionInfo2Response: VersionInfo2Response | null;
  urlInfoResponse: UrlInfoResponse | null;
}

export const initialState: State = {
  versionInfo2Response: null,
  urlInfoResponse: null
};

export function selectors<S>(selector: Selector<any, State>) {
  return {
    versionInfo2Response: createSelector(
      selector,
      (state: State) => state.versionInfo2Response
    ),
    urlInfoResponse: createSelector(
      selector,
      (state: State) => state.urlInfoResponse
    )
  };
}
